package com.example.jairo.wristcare.modelo;

/**
 * Created by Jairo on 08/04/2017.
 */

import android.content.ContentValues;
import android.database.Cursor;

import com.example.jairo.wristcare.modelo.ProgramsContract.ProgramEntry;

/**
 * Entidad "Programa"
 */
public class Program {
    private String name;
    private String fcreation;
    private String fclose;
    private int open;
    private double initFlex;
    private double initExt;
    private double initAbd;
    private double initAdu;
    private double initSup;
    private double initPro;


    public Program(String name,
                   String fcreation, String fclose,
                   int open, double initFlex, double initExt, double initAbd, double initAdu, double initSup, double initPro) {
        this.name = name;
        this.fcreation = fcreation;
        this.fclose = fclose;
        this.open = open;
        this.initFlex = initFlex;
        this.initExt = initExt;
        this.initAbd = initAbd;
        this.initAdu = initAdu;
        this.initSup = initSup;
        this.initPro = initPro;

    }

    public Program(Cursor cursor) {
        name = cursor.getString(cursor.getColumnIndex(ProgramEntry.NAME));
        fcreation = cursor.getString(cursor.getColumnIndex(ProgramEntry.FCREATION));
        fclose = cursor.getString(cursor.getColumnIndex(ProgramEntry.FCLOSE));
        open = cursor.getInt(cursor.getColumnIndex(ProgramEntry.OPEN));
        initFlex = cursor.getDouble(cursor.getColumnIndex(ProgramEntry.INITFLEX));
        initExt = cursor.getDouble(cursor.getColumnIndex(ProgramEntry.INITEXT));
        initAbd = cursor.getDouble(cursor.getColumnIndex(ProgramEntry.INITABD));
        initAdu = cursor.getDouble(cursor.getColumnIndex(ProgramEntry.INITADU));
        initSup = cursor.getDouble(cursor.getColumnIndex(ProgramEntry.INITSUP));
        initPro = cursor.getDouble(cursor.getColumnIndex(ProgramEntry.INITPRO));
    }

    public ContentValues toContentValues() {
        ContentValues values = new ContentValues();
        values.put(ProgramEntry.NAME, name);
        values.put(ProgramEntry.FCREATION, fcreation);
        values.put(ProgramEntry.FCLOSE, fclose);
        values.put(ProgramEntry.OPEN, open);
        values.put(ProgramEntry.INITFLEX, initFlex);
        values.put(ProgramEntry.INITEXT, initExt);
        values.put(ProgramEntry.INITABD, initAbd);
        values.put(ProgramEntry.INITADU, initAdu);
        values.put(ProgramEntry.INITSUP, initSup);
        values.put(ProgramEntry.INITPRO, initPro);
        return values;
    }

    public String getName() {
        return name;
    }

    public String getFcreation() {
        return fcreation;
    }

    public String getFclose() {
        return fclose;
    }

    public int getOpen() {
        return open;
    }

    public double getInitFlex() {
        return initFlex;
    }

    public double getInitExt() {
        return initExt;
    }

    public double getInitAbd() {
        return initAbd;
    }

    public double getInitAdu() {
        return initAdu;
    }

    public double getInitSup() {
        return initSup;
    }

    public double getInitPro() {
        return initPro;
    }

    public void setOpen(int i) { this.open = i; }

    public void setFclose (String dateC) { this.fclose = dateC; }

}

