package com.example.jairo.wristcare.modelo;

import android.content.ContentValues;
import android.database.Cursor;

import com.example.jairo.wristcare.modelo.ProgramsContract.SessionEntry;

/**
 * Created by Jaito on 17/04/2017.
 */
public class Session {
    private String fecha;
    private double anFlex;
    private double anExt;
    private double anAbd;
    private double anAdu;
    private double anSup;
    private double anPro;
    private int id_program;

    public Session(String fecha, double anFlex, double anExt, double anAbd, double anAdu, double anSup, double anPro, int id_program) {
        this.fecha = fecha;
        this.anFlex = anFlex;
        this.anExt = anExt;
        this.anAbd = anAbd;
        this.anAdu = anAdu;
        this.anSup = anSup;
        this.anPro = anPro;
        this.id_program = id_program;
    }

    public Session(Cursor cursor) {
        fecha = cursor.getString(cursor.getColumnIndex(SessionEntry.FECHA));
        anFlex = cursor.getDouble(cursor.getColumnIndex(SessionEntry.ANFLEX));
        anExt = cursor.getDouble(cursor.getColumnIndex(SessionEntry.ANEXT));
        anAbd = cursor.getDouble(cursor.getColumnIndex(SessionEntry.ANABD));
        anAdu = cursor.getDouble(cursor.getColumnIndex(SessionEntry.ANADU));
        anSup = cursor.getDouble(cursor.getColumnIndex(SessionEntry.ANSUP));
        anPro = cursor.getDouble(cursor.getColumnIndex(SessionEntry.ANPRO));
        id_program = cursor.getInt(cursor.getColumnIndex(SessionEntry.ID_PROGRAM));
    }

    public ContentValues toContentValues() {
        ContentValues values = new ContentValues();
        values.put(SessionEntry.FECHA, fecha);
        values.put(SessionEntry.ANFLEX, anFlex);
        values.put(SessionEntry.ANEXT, anExt);
        values.put(SessionEntry.ANABD, anAbd);
        values.put(SessionEntry.ANADU, anAdu);
        values.put(SessionEntry.ANSUP, anSup);
        values.put(SessionEntry.ANPRO, anPro);
        values.put(SessionEntry.ID_PROGRAM, id_program);
        return values;
    }

    public String getFecha(){
        return fecha;
    }

    public double getAnFlex() {
        return anFlex;
    }

    public double getAnExt() {
        return anExt;
    }

    public double getAnAbd() {
        return anAbd;
    }

    public double getAnAdu() {
        return anAdu;
    }

    public double getAnSup() {
        return anSup;
    }

    public double getAnPro() {
        return anPro;
    }

    public int getId_program() {
        return id_program;
    }

    public void setAnFlex(Double flex) {
        this.anFlex = flex;
    }

    public void setAnExt(Double ext) {
        this.anExt = ext;
    }

    public void setAnAbd(Double abd) {
        this.anAbd = abd;
    }

    public void setAnAdu(Double adu) {
        this.anAdu = adu;
    }

    public void setAnSup(Double sup) {
        this.anSup = sup;
    }

    public void setAnPro(Double pro) {
        this.anPro = pro;
    }
}
