package com.example.jairo.wristcare.presentador;

import android.content.Context;
import android.database.Cursor;
import android.graphics.Color;

import com.example.jairo.wristcare.modelo.Program;
import com.example.jairo.wristcare.modelo.ProgramsDbHelper;
import com.example.jairo.wristcare.vista.AbdAduFragmentView;
import com.github.mikephil.charting.charts.LineChart;
import com.github.mikephil.charting.components.Description;
import com.github.mikephil.charting.components.LimitLine;
import com.github.mikephil.charting.components.YAxis;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.data.LineDataSet;
import com.github.mikephil.charting.interfaces.datasets.ILineDataSet;

import java.text.DateFormat;
import java.text.DateFormatSymbols;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Locale;

/**
 * Created by Jaito on 09/06/2017.
 */
public class AbdAduFragmentPresenter {

    private ProgramsDbHelper mProgramsDbHelper;
    private AbdAduFragmentView mAbdAduFragmentView;

    public AbdAduFragmentPresenter(Context context,AbdAduFragmentView view){

        mProgramsDbHelper = new ProgramsDbHelper(context);
        mAbdAduFragmentView = view;

    }

    public void setDataChart(String programName, LineChart mChart, int pos){

        ArrayList<Entry> abd, adu, mejoraAbd, mejoraAdu;
        int type;
        double[] initValues;
        Cursor c;
        Description desc = new Description();

        ArrayList<ILineDataSet> mLineDataSets;
        LineDataSet lineDataSet1, lineDataSet2;

        mLineDataSets = new ArrayList<>();
        mLineDataSets.clear();

        c = getDataByName(programName);
        abd = getEntries(c, 1);
        c = getDataByName(programName);
        adu = getEntries(c, 2);

        initValues = getInitValues(programName);

        if(!abd.isEmpty() || !adu.isEmpty()) {

            mejoraAbd = getMejora(abd);
            mejoraAdu = getMejora(adu);

            type = getType(pos);

            YAxis leftAxis = mChart.getAxisLeft();
            LimitLine l1;

            switch (pos) {
                case 0:
                    leftAxis.setAxisMaximum(Math.round(getMaximumAbdAdu(abd, adu) * 1.20));
                    leftAxis.removeAllLimitLines();
                    desc.setText("Comparativa Abducción-Aducción");
                    break;
                case 1:
                    l1 = new LimitLine(Math.round(initValues[0]), "Referencia Abducción");
                    l1.setLineColor(Color.parseColor("#0095ff"));
                    l1.setLineWidth(4f);
                    l1.setTextColor(Color.BLACK);
                    l1.setTextSize(12f);

                    leftAxis.setAxisMaximum(Math.round((Math.max(initValues[0], getMaximumAbdAdu(abd, adu))) * 1.20));

                    leftAxis.removeAllLimitLines();
                    leftAxis.addLimitLine(l1);

                    desc.setText("Abducción");
                    break;
                case 2:
                    l1 = new LimitLine(Math.round(initValues[1]), "Referencia Aducción");
                    l1.setLineColor(Color.parseColor("#0095ff"));
                    l1.setLineWidth(4f);
                    l1.setTextColor(Color.BLACK);
                    l1.setTextSize(12f);

                    leftAxis.setAxisMaximum(Math.round((Math.max(initValues[1], getMaximumAbdAdu(abd, adu))) * 1.20));

                    leftAxis.removeAllLimitLines();
                    leftAxis.addLimitLine(l1);

                    desc.setText("Aducción");
                    break;
                case 3:
                    leftAxis.removeAllLimitLines();
                    leftAxis.setAxisMaximum(getMaximumMejora(mejoraAbd, mejoraAdu));
                    desc.setText("Comparativa de las mejoras medias");
                default:
                    break;
            }

            boolean drawvalues = true;
            if (type == 3) {
                drawvalues = false;

            }
            if (type == 1 || type == 3) {
                lineDataSet1 = new LineDataSet(abd, "Abducción");
                lineDataSet1.setColor(Color.parseColor("#94d4ff"));
                mLineDataSets.add(lineDataSet1);

                if (drawvalues) {
                    lineDataSet1.setValueTextSize(10f);
                }
                lineDataSet1.setDrawValues(drawvalues);
                lineDataSet1.setLineWidth(4);
                lineDataSet1.setCircleRadius(5);
                lineDataSet1.setCircleHoleRadius(2);
                lineDataSet1.setCircleColor(Color.parseColor("#94d4ff"));

                if (type == 1) {
                    LineDataSet lineDataSetM = new LineDataSet(mejoraAbd, "Mejora media");
                    lineDataSetM.setColor(Color.parseColor("#c0e303"));
                    mLineDataSets.add(lineDataSetM);

                    lineDataSetM.setValueTextSize(10f);
                    lineDataSetM.setDrawValues(true);
                    lineDataSetM.setLineWidth(4);
                    lineDataSetM.setCircleRadius(5);
                    lineDataSetM.setCircleHoleRadius(2);
                    lineDataSetM.setCircleColor(Color.parseColor("#c0e303"));
                }

            }
            if (type == 2 || type == 3) {
                lineDataSet2 = new LineDataSet(adu, "Aducción");
                lineDataSet2.setColor(Color.parseColor("#007a8a"));
                mLineDataSets.add(lineDataSet2);

                if (drawvalues) {
                    lineDataSet2.setValueTextSize(10f);
                }
                lineDataSet2.setDrawValues(drawvalues);
                lineDataSet2.setLineWidth(4);
                lineDataSet2.setCircleRadius(5);
                lineDataSet2.setCircleHoleRadius(2);
                lineDataSet2.setCircleColor(Color.parseColor("#007a8a"));

                if (type == 2) {
                    LineDataSet lineDataSetM = new LineDataSet(mejoraAdu, "Mejora media");
                    lineDataSetM.setColor(Color.parseColor("#c0e303"));
                    mLineDataSets.add(lineDataSetM);

                    lineDataSetM.setValueTextSize(10f);
                    lineDataSetM.setDrawValues(true);
                    lineDataSetM.setLineWidth(4);
                    lineDataSetM.setCircleRadius(5);
                    lineDataSetM.setCircleHoleRadius(2);
                    lineDataSetM.setCircleColor(Color.parseColor("#c0e303"));
                }
            }

            if (type == 4) {
                LineDataSet lineDataSetM = new LineDataSet(mejoraAbd, "Mejora abducción");
                lineDataSetM.setColor(Color.parseColor("#07bb87"));
                mLineDataSets.add(lineDataSetM);

                lineDataSetM.setValueTextSize(10f);
                lineDataSetM.setDrawValues(true);
                lineDataSetM.setLineWidth(4);
                lineDataSetM.setCircleRadius(5);
                lineDataSetM.setCircleHoleRadius(2);
                lineDataSetM.setCircleColor(Color.parseColor("#07bb87"));

                LineDataSet lineDataSetM2 = new LineDataSet(mejoraAdu, "Mejora aducción");
                lineDataSetM2.setColor(Color.parseColor("#c0e303"));
                mLineDataSets.add(lineDataSetM2);

                lineDataSetM2.setValueTextSize(10f);
                lineDataSetM2.setDrawValues(true);
                lineDataSetM2.setLineWidth(4);
                lineDataSetM2.setCircleRadius(5);
                lineDataSetM2.setCircleHoleRadius(2);
                lineDataSetM2.setCircleColor(Color.parseColor("#c0e303"));
            }
            c.close();
        }

        mAbdAduFragmentView.setDataChart(mLineDataSets, desc);

    }

    public void getAxis(String programName){
        Cursor c = getDataByName(programName);
        mAbdAduFragmentView.setAxisStyle(getDateStrings(c));
    }

    private int getType(int pos){
        int type = 0;

        switch (pos){
            case 0:
                type = 3;
                break;
            case 1:
                type = 1;
                break;
            case 2:
                type = 2;
                break;
            case 3:
                type = 4;
                break;
            default:
                break;
        }

        return type;
    }

    private ArrayList<Entry> getMejora(ArrayList<Entry> data){
        double valor;
        ArrayList<Double> mejora = new ArrayList<>();
        ArrayList<Entry> mejoraMedia = new ArrayList<>();
        mejoraMedia.add(new Entry(data.get(0).getX(),0f));
        for(int i = 1 ; i < data.size() ; i ++){
            valor = 0.0;
            mejora.add(i-1,Double.valueOf(data.get(i).getY() - data.get(i-1).getY()));
            for(int j = 0 ; j < mejora.size() ; j ++){
                valor += mejora.get(j);
            }
            mejoraMedia.add(new Entry(data.get(i).getX(),Float.parseFloat(String.valueOf(valor/Double.valueOf(mejora.size())))));
        }
        return mejoraMedia;
    }

    private String formatDate(String date){
        String format = date;
        Date d;
        DateFormatSymbols sym = DateFormatSymbols.getInstance(new Locale("es"));
        sym.setShortMonths(new String[]{"Ene","Feb","Mar","Abr","May","Jun","Jul","Ago","Sep","Oct","Nov","Dic"});
        DateFormat formatI = new SimpleDateFormat("yyyy-MM-dd", sym);
        DateFormat formatF = new SimpleDateFormat("dd MMM yy", sym);
        try {
            d = formatI.parse(date);
            format = formatF.format(d);
        } catch (ParseException e){

        }
        return format;
    }

    private Cursor getDataByName(String mProgramName) {
        return mProgramsDbHelper.getAbdAduByName(mProgramName);
    }

    private ArrayList<Entry> getEntries(Cursor c, int type) {
        ArrayList<Entry> data = new ArrayList<>();
        while (c != null && c.moveToNext()) {
            data.add(new Entry(c.getPosition(), c.getFloat(type)));
        }
        return data;
    }

    private String[] getDateStrings(Cursor c) {
        String[] strings = new String[c.getCount()];
        while (c.moveToNext()) {
            strings[c.getPosition()] = formatDate(c.getString(0));
        }
        return strings;
    }

    private double[] getInitValues(String programName){
        double[] initValues = new double[2];

        Cursor c = mProgramsDbHelper.getProgramByName(programName);
        if(c != null && c.moveToNext()) {
            Program p = new Program(c);
            initValues[0] = p.getInitAbd();
            initValues[1] = p.getInitAdu();
        }
        return initValues;
    }

    private long getMaximumAbdAdu(ArrayList<Entry> abd, ArrayList<Entry> adu){
        Float value = 0f;
        Float max;
        for(int i = 0 ; i < abd.size() ; i ++){
            max = Math.max(abd.get(i).getY(), adu.get(i).getY());
            if(max > value){
                value = max;
            }
        }
        return Math.round(value);
    }

    private long getMaximumMejora(ArrayList<Entry> mAb, ArrayList<Entry> mAd){
        Float value = 0f;
        Float max;
        for(int i = 0 ; i < mAb.size() ; i ++){
            max = Math.max(mAb.get(i).getY(), mAd.get(i).getY());
            if(max > value){
                value = max;
            }
        }
        return Math.round(value * 1.20);
    }

}
