package com.example.jairo.wristcare.presentador;

import android.content.Context;
import android.database.Cursor;

import com.example.jairo.wristcare.modelo.Program;
import com.example.jairo.wristcare.modelo.ProgramsDbHelper;
import com.example.jairo.wristcare.vista.ProgramDetailActivityView;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Created by Jairo on 07/06/2017.
 */
public class ProgramDetailActivityPresenter {

    private ProgramsDbHelper mProgramsDbHelper;
    private ProgramDetailActivityView mProgramDetailActivityView;

    public ProgramDetailActivityPresenter(Context context, ProgramDetailActivityView view){

        mProgramsDbHelper = new ProgramsDbHelper(context);
        mProgramDetailActivityView = view;

    }

    public void checkDaily(int pos, String programName){
        boolean flag = false;
        Cursor c;
        switch (pos){
            case 1:
                c = mProgramsDbHelper.getFlexExtTodayByName(programName);
                if(c != null && c.moveToNext()){
                    if(c.getDouble(0) != 0.0 && c.getDouble(1) != 0.0) {
                        flag = true;
                    }
                    c.close();
                }
                break;
            case 2:
                c = mProgramsDbHelper.getAbdAduTodayByName(programName);
                if(c != null && c.moveToNext()){
                    if(c.getDouble(0) != 0.0 && c.getDouble(1) != 0.0) {
                        flag = true;
                    }
                    c.close();
                }
                break;
            case 3:
                c = mProgramsDbHelper.getSupProTodayByName(programName);
                if(c != null && c.moveToNext()){
                    if(c.getDouble(0) != 0.0 && c.getDouble(1) != 0.0) {
                        flag = true;
                    }
                    c.close();
                }
                break;
            default:
                break;
        }

        mProgramDetailActivityView.checkDaily(flag, pos);
    }

    public void checkClosed(String programName){
        boolean closed = false;
        Cursor c = mProgramsDbHelper.getProgramByName(programName);
        if(c != null && c.moveToNext()){
            Program p = new Program(c);

            if(p.getOpen() == 1){
                closed = false;
            } else {
                closed = true;
            }
            c.close();
        }

        mProgramDetailActivityView.setTitle(closed);

    }

    public void deleteProgram(String programName){
        mProgramDetailActivityView.programDeleted(mProgramsDbHelper.deleteProgram(programName));
    }

    public void existsDataFlexExt(String programName){
        Cursor c = mProgramsDbHelper.getFlexExtByName(programName);
        mProgramDetailActivityView.numSessionsFlexExt(c.getCount());
        c.close();
    }

    public void existsDataAbdAdu(String programName){
        Cursor c = mProgramsDbHelper.getAbdAduByName(programName);
        mProgramDetailActivityView.numSessionsAbdAdu(c.getCount());
        c.close();
    }

    public void existsDataSupPro(String programName){
        Cursor c = mProgramsDbHelper.getSupPronByName(programName);
        mProgramDetailActivityView.numSessionsSupPro(c.getCount());
        c.close();
    }

    public void closeProgram(String programName){
        Cursor c = mProgramsDbHelper.getProgramByName(programName);
        if(c != null && c.moveToNext()){
            Program p = new Program(c);
            p.setOpen(0);
            p.setFclose(getDate());
            mProgramsDbHelper.updateProgram(p, programName);
            c.close();
        }
        mProgramDetailActivityView.programClosed();
    }

    private String getDate(){
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Date d = new Date();
        return format.format(d);
    }
}
