package com.example.jairo.wristcare.presentador;

import android.content.Context;
import android.database.Cursor;

import com.example.jairo.wristcare.modelo.Program;
import com.example.jairo.wristcare.modelo.ProgramsDbHelper;
import com.example.jairo.wristcare.vista.ProgramDetailFragmentView;

import java.text.DateFormat;
import java.text.DateFormatSymbols;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

/**
 * Created by Jaito on 08/06/2017.
 */
public class ProgramDetailFragmentPresenter {

    private ProgramsDbHelper mProgramsDbHelper;
    private ProgramDetailFragmentView mProgramDetailFragmentView;

    public ProgramDetailFragmentPresenter(Context context, ProgramDetailFragmentView view){

        mProgramsDbHelper = new ProgramsDbHelper(context);
        mProgramDetailFragmentView = view;

    }

    public void getData(String programName){

        Cursor c = mProgramsDbHelper.getProgramByName(programName);
        if(c != null && c.moveToNext()) {
            Program p = new Program(c);
            mProgramDetailFragmentView.setCreationDate(formatDate(p.getFcreation()));
            if (p.getOpen() == 1) {
                mProgramDetailFragmentView.setClosedDate("-");
            } else {
                mProgramDetailFragmentView.setClosedDate(formatDate(p.getFclose()));
            }
            c.close();
        }

        c = mProgramsDbHelper.getAllSessionsByName(programName);
        if(c != null && c.moveToNext()){
            mProgramDetailFragmentView.setLastSession(c.getString(0));
            mProgramDetailFragmentView.setNumSessions(c.getCount());
        } else {
            mProgramDetailFragmentView.setLastSession("-");
            mProgramDetailFragmentView.setNumSessions(0);
        }
    }

    private String formatDate(String date){
        String format = date;
        Date d;
        DateFormatSymbols sym = DateFormatSymbols.getInstance(new Locale("es"));
        sym.setShortMonths(new String[]{"Ene","Feb","Mar","Abr","May","Jun","Jul","Ago","Sep","Oct","Nov","Dic"});
        DateFormat formatI = new SimpleDateFormat("yyyy-MM-dd", sym);
        DateFormat formatF = new SimpleDateFormat("dd MMM yy", sym);
        try {
            d = formatI.parse(date);
            format = formatF.format(d);
        } catch (ParseException e){

        }
        return format;
    }


}
