package com.example.jairo.wristcare.vista;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;

import com.example.jairo.wristcare.R;

public class AbdAduExerciseActivity extends AppCompatActivity {

    public static final int REQUEST_ADD_ABD = 2;
    public static String programName;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_abd_adu_exercise);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        if(this.getCallingActivity().getClassName().equals(FlexExtExerciseActivity.class.getName())){
            programName = getIntent().getExtras().getString("ARG_PROGRAM_NAME");
            setTitle("Referencia Abducción");
        } else {
            programName = getIntent().getStringExtra(ProgramDetailActivity.EXTRA_PROGRAM_NAME);
            setTitle("Nuevo ejercicio de Abducción");
        }



        AbdAduExerciseFragment abdAduExerciseFragment = (AbdAduExerciseFragment)
                getSupportFragmentManager().findFragmentById(R.id.abd_adu_exercise_container);
        if (abdAduExerciseFragment == null) {
            abdAduExerciseFragment = AbdAduExerciseFragment.newInstance(programName);
            getSupportFragmentManager()
                    .beginTransaction()
                    .add(R.id.abd_adu_exercise_container, abdAduExerciseFragment)
                    .commit();
        }
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

}
