package com.example.jairo.wristcare.vista;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;

import com.example.jairo.wristcare.R;

public class FlexExtExerciseActivity extends AppCompatActivity {
    public static final int REQUEST_ADD_FLEX = 1;
    public static String programName;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_flex_ext_exercise);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        if(this.getCallingActivity().getClassName().equals(AddProgramActivity.class.getName())){
            programName = getIntent().getExtras().getString("ARG_PROGRAM_NAME");
            setTitle("Referencia Flexión");
        } else {
            programName = getIntent().getStringExtra(ProgramDetailActivity.EXTRA_PROGRAM_NAME);
            setTitle("Nuevo ejercicio de Flexión");
        }



        FlexExtExerciseFragment flexExtExerciseFragment = (FlexExtExerciseFragment)
                getSupportFragmentManager().findFragmentById(R.id.flex_ext_exercise_container);
        if (flexExtExerciseFragment == null) {
            flexExtExerciseFragment = FlexExtExerciseFragment.newInstance(programName);
            getSupportFragmentManager()
                    .beginTransaction()
                    .add(R.id.flex_ext_exercise_container, flexExtExerciseFragment)
                    .commit();
        }
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

}
