package com.example.jairo.wristcare.vista;


import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.ColorStateList;
import android.graphics.Color;
import android.hardware.SensorManager;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.Fragment;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.jairo.wristcare.R;
import com.example.jairo.wristcare.presentador.FlexExtExerciseFragmentPresenter;


public class FlexExtExerciseFragment extends Fragment implements FlexExtExerciseFragmentView {
    private static final String ARG_PROGRAM_NAME = "arg_program_name";
    private static int screen;
    private boolean init;

    private String mProgramName;
    private FlexExtExerciseFragmentPresenter mPresenter;

    private static double initialDegree, finalDegree, flex, ext;

    private ImageView image;
    private Toolbar toolbar;
    private MediaPlayer mp, mpShort, mpError;
    private CountDownTimer timerStart, timerExercise;
    private FloatingActionButton fab, fabSave;
    private TextView mTextDegree, mTextDiff, mTextLastSession;


    public FlexExtExerciseFragment() {
        // Required empty public constructor
    }

    public static FlexExtExerciseFragment newInstance(String programName) {
        FlexExtExerciseFragment fragment = new FlexExtExerciseFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PROGRAM_NAME, programName);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);

        String nombreClase = getActivity().getCallingActivity().getClassName();
        String nombreAddProgram = AddProgramActivity.class.getName();
        init = (nombreAddProgram.equals(nombreClase));

        mProgramName = ((FlexExtExerciseActivity)getActivity()).programName;

        mPresenter = new FlexExtExerciseFragmentPresenter(getActivity(), this, (SensorManager) getActivity().getSystemService(Context.SENSOR_SERVICE));

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        super.onCreateView(inflater,container,savedInstanceState);
        View v = inflater.inflate(R.layout.fragment_flex_ext_exercise, container, false);

        screen = 0;

        toolbar = (Toolbar) getActivity().findViewById(R.id.toolbar);

        fab = (FloatingActionButton) getActivity().findViewById(R.id.fabFlexExt);
        fabSave = (FloatingActionButton) getActivity().findViewById(R.id.fabSave);
        fabSave.hide();

        mp = MediaPlayer.create(getActivity(), R.raw.beep);
        mpShort = MediaPlayer.create(getActivity(), R.raw.beep_short);
        mpError = MediaPlayer.create(getActivity(), R.raw.error);

        mTextDegree = (TextView) getActivity().findViewById(R.id.textDegrees);
        mTextDiff = (TextView) getActivity().findViewById(R.id.textFinalDegree);
        mTextLastSession = (TextView) getActivity().findViewById(R.id.textView);

        fabSave.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(screen == 0) {
                    fabSave.hide();
                    if(init){
                        toolbar.setTitle("Referencia Extensión");
                    } else {
                        toolbar.setTitle("Nuevo ejercicio de Extensión");
                    }
                    image = (ImageView) getActivity().findViewById(R.id.imageViewExercise);
                    if(!init) {
                        image.setImageResource(R.drawable.extension);
                    } else {
                        image.setImageResource(R.drawable.extensioncalib);
                    }
                    resetView();
                    screen = 1;
                } else if (screen == 1 && !init) {
                    mPresenter.updateOrCreateSession(mProgramName, flex, ext);

                    getActivity().setResult(FlexExtExerciseActivity.REQUEST_ADD_FLEX);
                    getActivity().finish();
                } else if (screen == 1 && init){
                    Intent intent = new Intent(getActivity(), AbdAduExerciseActivity.class);
                    intent.putExtra("ARG_PROGRAM_NAME", mProgramName);
                    intent.putExtra("flex", String.valueOf(flex));
                    intent.putExtra("ext", String.valueOf(ext));
                    startActivityForResult(intent, 1);
                }
            }
        });


        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(fab.getBackgroundTintList() == ColorStateList.valueOf(Color.parseColor("#c0e303"))) {
                    fab.setClickable(false);
                    timerStart = new CountDownTimer(6000, 1000) {

                        public void onTick(long millisUntilFinished) {

                            int num = Math.round(millisUntilFinished * 0.001f) - 1;
                            switch (num){
                                case 1:
                                    mpShort.setAudioStreamType(AudioManager.STREAM_MUSIC);
                                    mpShort.start();
                                    fab.setImageResource(R.drawable.ic_1);
                                    break;
                                case 2:
                                    mpShort.setAudioStreamType(AudioManager.STREAM_MUSIC);
                                    mpShort.start();
                                    fab.setImageResource(R.drawable.ic_2);
                                    break;
                                case 3:
                                    mpShort.setAudioStreamType(AudioManager.STREAM_MUSIC);
                                    mpShort.start();
                                    fab.setImageResource(R.drawable.ic_3);
                                    break;
                                case 4:
                                    fab.setImageResource(R.drawable.ic_4);
                                    break;
                                case 5:
                                    fab.setImageResource(R.drawable.ic_5);
                                    break;
                                default:
                                    break;
                            }
                        }

                        public void onFinish() {
                            if(mPresenter.checkRoll()){
                                mp.setAudioStreamType(AudioManager.STREAM_MUSIC);
                                mp.start();
                                fab.setImageResource(R.drawable.ic_stop);
                                fab.setBackgroundTintList(ColorStateList.valueOf(Color.parseColor("#D32F2F")));
                                fab.setClickable(true);
                                exerciseStarted();
                            } else {
                                mpError.setAudioStreamType(AudioManager.STREAM_MUSIC);
                                mpError.start();
                                fab.setClickable(true);
                                Toast.makeText(getActivity(),
                                        "Coloque el dispositivo como se indica", Toast.LENGTH_SHORT).show();
                                resetView();
                            }
                        }
                    }.start();
                } else if(fab.getBackgroundTintList() == ColorStateList.valueOf(Color.parseColor("#D32F2F"))) {
                    resetView();
                } else {
                    resetView();
                    fab.callOnClick();
                }
            }
        });
        // Inflate the layout for this fragment
        return v;
    }


    @Override
    public void setInitDegree(double init) {
        initialDegree = init;
    }

    @Override
    public void setFinalDegree(double end) {
        finalDegree = end;
    }

    @Override
    public void setCalculatedDegree(String degree) {
        String string;
        if(screen == 0){
            flex = Double.valueOf(degree);
        } else {
            ext = Double.valueOf(degree);
        }

        string = degree + "º";

        mTextDegree = (TextView) getActivity().findViewById(R.id.textDegrees);
        mTextDegree.setText(string);
    }

    @Override
    public void setDiffLastSessionDegree(String degree) {
        String string;
        mTextDiff = (TextView) getActivity().findViewById(R.id.textFinalDegree);
        mTextLastSession = (TextView) getActivity().findViewById(R.id.textView);
        string = "Diferencia última sesión: ";

        if(!init) {
            if (Double.valueOf(degree) > 0.0) {
                mTextLastSession.setText(string);
                string = "+" + degree + "º";
                mTextDiff.setText(string);
                mTextDiff.setTextColor(Color.parseColor("#07bb87"));
            } else if (Double.valueOf(degree) < 0.0) {
                mTextLastSession.setText(string);
                string = degree + "º";
                mTextDiff.setText(string);
                mTextDiff.setTextColor(Color.parseColor("#D32F2F"));
            } else {
                mTextLastSession.setText(string);
                mTextDiff.setText(degree);
                mTextDiff.setTextColor(Color.GRAY);
            }
        }
    }

    @Override
    public void onStop() {
        super.onStop();
        screen = 0;
        mPresenter.unregisterListener();
    }

    @Override
    public void onPause() {
        super.onPause();
        screen = 0;
        mPresenter.unregisterListener();
    }

    @Override
    public void onResume() {
        super.onResume();
        screen = 0;
        mPresenter.registerSensorManagerListeners();
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (Activity.RESULT_OK == resultCode) {
            getActivity().setResult(Activity.RESULT_OK);
        } else {
            getActivity().setResult(Activity.RESULT_CANCELED);
        }

        getActivity().finish();
    }

    private void resetView(){
        if(timerStart != null){
            timerStart.cancel();
        }
        if (timerExercise != null) {
            timerExercise.cancel();
        }
        if(mTextDiff != null) {
            mTextDiff.setText("");
        }
        if(mTextDegree != null){
            mTextDegree.setText("");
        }
        if(mTextLastSession != null){
            mTextLastSession.setText("");
        }

        fab.setImageResource(R.drawable.ic_play);
        fab.setBackgroundTintList(ColorStateList.valueOf(Color.parseColor("#c0e303")));
        fabSave.hide();
    }

    private void exerciseStarted(){

        mPresenter.getInitDegree();

        timerExercise = new CountDownTimer(6000, 1000) {
            MediaPlayer mp = MediaPlayer.create(getActivity(), R.raw.beep);

            public void onTick(long millisUntilFinished) {
            }

            public void onFinish() {
                mp.setAudioStreamType(AudioManager.STREAM_MUSIC);
                mp.start();

                mPresenter.getFinalDegree();
                mPresenter.calculateDegree(initialDegree, finalDegree);
                mPresenter.calculateDiffLastSession(initialDegree, finalDegree, mProgramName, screen);

                fab.setImageResource(R.drawable.ic_repeat);
                fab.setBackgroundTintList(ColorStateList.valueOf(Color.parseColor("#2196F3")));

                if(screen == 1) {
                    fabSave.setImageResource(R.drawable.ic_save_exercise);
                }
                fabSave.show();

            }
        }.start();
    }
}
