package com.example.jairo.wristcare.vista;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.example.jairo.wristcare.R;
import com.example.jairo.wristcare.presentador.ProgramDetailFragmentPresenter;


public class ProgramDetailFragment extends Fragment implements ProgramDetailFragmentView {

    private ProgramDetailFragmentPresenter mPresenter;

    private String mProgramName;
    private TextView mDateCreation;
    private TextView mNumSessions;
    private TextView mDateClosed;
    private TextView mDateLastSession;

    public ProgramDetailFragment(){

    }

    @Override
    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);

        mProgramName = ((ProgramDetailActivity)getActivity()).programName;
        mPresenter = new ProgramDetailFragmentPresenter(getActivity(), this);

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View root = inflater.inflate(R.layout.fragment_program_detail, container, false);

        mDateCreation = (TextView) root.findViewById(R.id.tv_date_creation);
        mNumSessions = (TextView) root.findViewById(R.id.tv_num_sessions);
        mDateClosed = (TextView) root.findViewById(R.id.tv_date_end_program);
        mDateLastSession = (TextView) root.findViewById(R.id.tv_date_last_session);

        mPresenter.getData(mProgramName);

        return root;
    }

    @Override
    public void setCreationDate(String creationDate) {
        mDateCreation.setText(creationDate);
    }

    @Override
    public void setLastSession(String lastSession) {
        mDateLastSession.setText(lastSession);
    }

    @Override
    public void setNumSessions(int numSessions) {
        mNumSessions.setText(String.valueOf(numSessions));
    }

    @Override
    public void setClosedDate(String closedDate) {
        mDateClosed.setText(closedDate);
    }

}
