package com.example.jairo.wristcare.vista;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;

import com.example.jairo.wristcare.R;

public class SupProExerciseActivity extends AppCompatActivity {
    public static final int REQUEST_ADD_SUP = 3;
    public static String programName;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_sup_pro_exercise);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        if(this.getCallingActivity().getClassName().equals(AbdAduExerciseActivity.class.getName())){
            programName = getIntent().getExtras().getString("ARG_PROGRAM_NAME");
            setTitle("Referencia Supinación");
        } else {
            programName = getIntent().getStringExtra(ProgramDetailActivity.EXTRA_PROGRAM_NAME);
            setTitle("Nuevo ejercicio de Supinación");
        }

        SupProExerciseFragment supProExerciseFragment = (SupProExerciseFragment)
                getSupportFragmentManager().findFragmentById(R.id.sup_pro_exercise_container);
        if (supProExerciseFragment == null) {
            supProExerciseFragment = SupProExerciseFragment.newInstance(programName);
            getSupportFragmentManager()
                    .beginTransaction()
                    .add(R.id.sup_pro_exercise_container, supProExerciseFragment)
                    .commit();
        }
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }
}
